/**
 * synchonrizes communication between amd and non-amd world
 *
 */
define(['require'], function (require) {
	var queues = [];

	function create(queueName, scope) {
		var aqueue;

		if(isExisting(queueName, scope)) return;

		if (!scope) {
			scope = window;
		}

		if ('undefined' === typeof(scope[queueName])) {
			scope[queueName] = [];
		}
		aqueue = scope[queueName];

		queues.push([queueName,scope]);

		aqueue.execute = function () {
			var value, dependency, func, args;

			while (this.length > 0) {
				value = this.shift();
				dependency = value[0];
				func = value[1];

				if ("function" === typeof func) {

					if (! (dependency instanceof Array) ) {
						dependency = [dependency];
					}
					require(dependency, func);
				} else {

					func.replace(/\s/g, ''); //.trim();
					args = value.slice(2);
					/*if (-1 === dependency.indexOf('component/')) {
						dependency = 'component/' + dependency;  // HACKFIX: move to vendor, if server-app hasn't yet => only vendor possible right now
					}*/
					(function(func, args){
						require([dependency], function (dep) {
							//check if return value is probably a constructor function
							if(Object.prototype.toString.call(dep[func]) === '[object Function]'){
								dep[func].apply(dep, args);
							}
						});
					})(func, args);
				}
			}
		};

		aqueue.push = function (value) {
			var that = this;
			Array.prototype.push.call(that, value);
			that.execute();
		};

		aqueue.execute();

		return this;
	}

	function isExisting(queueName, scope){
		var i;
		for(i=0;i<queues.length;i++){
			if(queues[i][0].indexOf(queueName) !== -1){
				return true;
			}
		}
		return false;
	}

	return {

		/*
		 * function create (queueName)
		 * creates a named global queue (like _caq) and executes everything pushed to it
		 *
		 * global usage:
		 * window._caq = window._caq || [];
		 * window._caq.push([DEPENDENCY-STRING, COMMAND, ARGUMENTS...]);
		 * window._caq.push([ [DEPENDENCY- ARRAY], FUNCTION]);
		 */
		create:create,
		isExisting: isExisting
	};
});
