define(['module','component/mustache/mustache'], function(module, mustache){

	var test = Object.prototype.toString,

		isArray = function(val) {
			return test.call(val) === '[object Array]';
		},

		isFunction = function(val) {
			return test.call(val) === '[object Function]';
		},

		isString = function(val){
			return typeof val === 'string';
		},

		isObject = function(val){
			return test.call(val) === '[object Object]';
		},

		render = function(tmpl, obj){

			var fullFilledParam, tmplTMP,
				i;

			if(typeof tmpl === 'string') {

				fullFilledParam = mustache.render(tmpl, obj);

			} else if(isArray(tmpl)) { //GoogleAnalytics Array Mapping tmpl is Array at this moment
				tmplTMP = tmplTMP || [];
				for(i=0; i < tmpl.length ; i += 1){
					tmplTMP[i] = this.render(tmpl[i], obj);
				}
				fullFilledParam = tmplTMP;

			} else if(isFunction(tmpl)) { //if tmpl is a function add the function to its searched object / add render as well to use it within the added function
				//key from config pool
				try{
					fullFilledParam = tmpl.call(this, obj);
				}catch(e){
					fullFilledParam = "ERROR - "+module.id;
				}
			} else if(isObject(tmpl)) {
				tmplTMP = tmplTMP || {};
				//render recursive if tmpl is an object
				for(i in tmpl){
					tmplTMP[i] = this.render(tmpl[i], obj);
				}

				fullFilledParam = tmplTMP;

			} else {

				fullFilledParam = tmpl;

			}

			return fullFilledParam;
		};

	return {
		isString : isString,
		isArray : isArray,
		isFunction : isFunction,
		isObject: isObject,
		render : render
	};
});