define(['jquery', 'component/core/mediator','component/fep-chip-widgets/js/jquery-nouislider/jquery.nouislider','requireCSS!component/fep-chip-widgets/js/jquery-nouislider/jquery.nouislider.css'], function ($, mediator) {
    "use strict";

    var defaults = {
        "CLASS_STATUS_SUBMITTING": 'is-inprogress',
        "CLASS_STATUS_SLIDERCHANGING": 'is-sliderchanging'
    };

    function _init (el) {
        var $el = $(el),
            $slider = $($el.find('.slider').get(0));

        mediator.subscribe('check24.slider.on.set', function(){
            if($el.hasClass(defaults.CLASS_STATUS_SLIDERCHANGING)) {
                $el.removeClass(defaults.CLASS_STATUS_SLIDERCHANGING);
                var val = $slider.val();
                $($el.find('.speed_value')).removeClass('current');
                $($el.find('.speed_value[data-value="'+val+'"]').get(0)).addClass('current');
            }
        });

        mediator.subscribe('check24.form.submit', function(){
            if ($el.hasClass(defaults.CLASS_STATUS_SUBMITTING)) {
                $el.removeClass(defaults.CLASS_STATUS_SUBMITTING);
                var location = 'http://x.chip.de/linktrack/check24/?url=',
                    url = $($el.find('.widget_form').get(0)).attr('action'),
                    params = [],
                    areacode = $($el.find('.areacode_input').get(0)).val();
                if ('' != areacode) {
                    if (!areacode.match(/^\d+$/)) {
                        $el.addClass('has-areacodeerror');
                        return false;
                    }
                    params.push('area=' + areacode);
                }
                params.push('speed=' + $slider.val());
                params = params.join('&');
                url += '?' + params;
                location += encodeURIComponent(url);

                var widget = 'c24_dsl';
                if ($el.parents('.col340-ri').length) {
                    widget += '_side';
                } else {
                    widget += '_main';
                }
                location += '&widgetname=' + widget;

                window.location = location;
            }
        });

        $slider.noUiSlider({
            start: [25000],
            range: {
                'min': [16000, 9000],
                '34%': [25000, 25000],
                '66%': [50000, 50000],
                'max': [100000]
            },
            serialization: {
                format: {
                    decimals: 0
                }
            }
        }).ready(function(){
            $el.addClass(defaults.CLASS_STATUS_SLIDERCHANGING);
            mediator.publish('check24.slider.on.set');
        });

        $slider.on('set', function(){
            $el.addClass(defaults.CLASS_STATUS_SLIDERCHANGING);
            mediator.publish('check24.slider.on.set');
        });

        $el.on('click', '.speed_value', function(){
            $slider.val([$(this).data('value')], {
                animate: true
            });
            $el.addClass(defaults.CLASS_STATUS_SLIDERCHANGING);
            mediator.publish('check24.slider.on.set');
        });

        $el.on('click', '.widget_button', function(){
            $el.addClass(defaults.CLASS_STATUS_SUBMITTING);
            mediator.publish('check24.form.submit');
        });

        $($el.find('form.widget_form').get(0)).on('submit', function(e){
            e.preventDefault();
            e.stopPropagation();
            $el.addClass(defaults.CLASS_STATUS_SUBMITTING);
            mediator.publish('check24.form.submit');
        });
    }

    return {
        "init": function (el, options) {
            _init(el);
        }
    };
});