define(['jquery', 'component/core/mediator'], function ($, mediator) {
    "use strict";

    var defaults = {
        "CLASS_STATUS_SUBMITTING": 'is-inprogress'
    };

    function _init (el) {
        var $el = $(el);

        mediator.subscribe('check24energy.form.submit', function(){
            if ($el.hasClass(defaults.CLASS_STATUS_SUBMITTING)) {
                $el.removeClass(defaults.CLASS_STATUS_SUBMITTING);
                var location = 'http://x.chip.de/linktrack/check24/?url=',
                    url = $($el.find('.widget_form.energy').get(0)).attr('action'),
                    params = [],
                    zipcode = $($el.find('.zipcode_input').get(0)).val(),
                    totalconsumption_energy = $($el.find('.totalconsumption_input').get(0)).val(),
                    eco = $($el.find('.widget_form.energy input#c24api_eco:checked').get(0)).val();

                if ('' != zipcode) {
                    if (!zipcode.match(/^[0-9]{5}$/)) {
                        $el.addClass('has-zipcodeerror');
                        return false;
                    }
                    params.push('check24_area=' + zipcode);
                }
                if ('yes' == eco) {
                    params.push('check24_eco=' + eco);
                }
                if ('' != totalconsumption_energy) {
                    var totalconsumption_nokwh = totalconsumption_energy.replace(/\D+/, '');
                    params.push('check24_totalconsumption=' + totalconsumption_nokwh);
                }

                params = params.join('&');
                url += '?' + params;
                location += encodeURIComponent(url);

                var widget = 'c24_strom';
                if ($el.parents('.col340-ri').length) {
                    widget += '_side';
                } else {
                    widget += '_main';
                }
                location += '&widgetname=' + widget;

                window.location = location;
            }
        });

        mediator.subscribe('check24gas.form.submit', function(){
            if ($el.hasClass(defaults.CLASS_STATUS_SUBMITTING)) {
                $el.removeClass(defaults.CLASS_STATUS_SUBMITTING);
                var location = 'http://x.chip.de/linktrack/check24/?url=',
                    url = $($el.find('.widget_form.gas').get(0)).attr('action'),
                    params = [],
                    zipcode = $($el.find('.zipcode_input').get(0)).val(),
                    totalconsumption_gas = $($el.find('.totalconsumption_input.gas').get(0)).val(),
                    eco = $($el.find('.widget_form.gas input#c24api_eco:checked').get(0)).val();

                if ('' != zipcode) {
                    if (!zipcode.match(/^[0-9]{5}$/)) {
                        $el.addClass('has-zipcodeerror');
                        return false;
                    }
                    params.push('check24_area=' + zipcode);
                }
                if ('yes' == eco) {
                    params.push('check24_eco=' + eco);
                }
                if ('' != totalconsumption_gas) {
                    var totalconsumption_nokwh = totalconsumption_gas.replace(/\D+/, '');
                    params.push('check24_totalconsumption=' + totalconsumption_nokwh);
                }

                params = params.join('&');
                url += '?' + params;
                location += encodeURIComponent(url);

                var widget = 'c24_gas';
                if ($el.parents('.col340-ri').length) {
                    widget += '_side';
                } else {
                    widget += '_main';
                }
                location += '&widgetname=' + widget;

                window.location = location;
            }
        });

        $el.on('click', '.widget_button.energy', function(){
            $el.addClass(defaults.CLASS_STATUS_SUBMITTING);
            mediator.publish('check24energy.form.submit');
        });

        $el.on('click', '.widget_button.gas', function(){
            $el.addClass(defaults.CLASS_STATUS_SUBMITTING);
            mediator.publish('check24gas.form.submit');
        });

        $($el.find('form.widget_form.energy').get(0)).on('submit', function(e){
            e.preventDefault();
            e.stopPropagation();
            $el.addClass(defaults.CLASS_STATUS_SUBMITTING);
            mediator.publish('check24energy.form.submit');
        });

        $($el.find('form.widget_form.gas').get(0)).on('submit', function(e){
            e.preventDefault();
            e.stopPropagation();
            $el.addClass(defaults.CLASS_STATUS_SUBMITTING);
            mediator.publish('check24gas.form.submit');
        });

        $( ".person_value_list input.totalconsumption_input" ).keyup(function() {
            var inputValue = this.value.substring(0);
            var inputValueNoLetters = inputValue.replace(/\D+/, '');
            switch(true) {
                case (inputValueNoLetters <= 2000 && inputValueNoLetters < 3500):
                    $(".person_value_list").find("input[id^='person-'][value='2000']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 3500 && inputValueNoLetters < 4250):
                    $(".person_value_list").find("input[id^='person-'][value='3500']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 4250 && inputValueNoLetters < 5000):
                    $(".person_value_list").find("input[id^='person-'][value='4250']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 5000 && inputValueNoLetters < 5750):
                    $(".person_value_list").find("input[id^='person-'][value='5000']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 5750 && inputValueNoLetters < 6500):
                    $(".person_value_list").find("input[id^='person-'][value='5750']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 6500 && inputValueNoLetters < 7250):
                    $(".person_value_list").find("input[id^='person-'][value='6500']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 7250 && inputValueNoLetters < 8000):
                    $(".person_value_list").find("input[id^='person-'][value='7250']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 8000) :
                    $(".person_value_list").find("input[id^='person-'][value='8000']").prop( "checked", true );
                    break;
            }
        });

        $( ".gas_value_list input.totalconsumption_input.gas" ).keyup(function() {
            var inputValue = this.value.substring(0);
            var inputValueNoLetters = inputValue.replace(/\D+/, '');
            switch(true) {
                case (inputValueNoLetters < 5000):
                    $(".gas_value_list").find("input[id^='gas-'][value='3800']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 5000 && inputValueNoLetters < 12000):
                    $(".gas_value_list").find("input[id^='gas-'][value='5000']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 12000 && inputValueNoLetters < 18000):
                    $(".gas_value_list").find("input[id^='gas-'][value='12000']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 18000 && inputValueNoLetters < 20000):
                    $(".gas_value_list").find("input[id^='gas-'][value='18000']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 20000 && inputValueNoLetters < 35000):
                    $(".gas_value_list").find("input[id^='gas-'][value='20000']").prop( "checked", true );
                    break;
                case (inputValueNoLetters >= 35000) :
                    $(".gas_value_list").find("input[id^='gas-'][value='35000']").prop( "checked", true );
                    break;
            }
        });

        $(".person_value_list label[for^='person-']").click(function () {
            var inputRadioValue = $(this).next(".person_value").val();
            $(this).parent().find("input.totalconsumption_input").val( inputRadioValue + " kWh" );
        });

        $(".gas_value_list label[for^='gas-']").click(function () {
            var inputRadioValue = $(this).next(".gas_value").val();
            $(this).parent().find("input.totalconsumption_input.gas").val( inputRadioValue + " kWh" );
        });
    }

    return {
        "init": function (el, options) {
            _init(el);
        }
    };
});