$(document).ready(function () {
    $.ui.autocomplete.prototype._resizeMenu = function () {
        var ul = this.menu.element;
        ul.outerWidth(this.element.outerWidth());
    };
    var werstreamesMainWrapper = $('#werstreamesMainWrapper');
    $('#searchMovieIcon').attr('src', 'img/werstreamtes/icon.svg');
    $('#werstreamtesGenreImageTop').attr('src', 'img/werstreamtes/' + werstreamesMainWrapper.attr('data-genre') + '.jpg');
    var view = werstreamesMainWrapper.attr('data-view');
    var version = werstreamesMainWrapper.attr('data-version');
    var searchAlert = $('#searchAlert');
    var searchInput = $('#searchInput');
    var searchAlertWrapper = $('#searchAlertWrapper');
    var searchAlertWrapperCloseIcon = $('#searchAlertWrapperCloseIcon');
    var searchResultWrapper = $('#searchResultWrapper');
    var searchIconMagnifyingGlass = $('#searchIconMagnifyingGlass');
    var werstreamtesSearchContainer = $('#werstreamtesSearchContainer');
    var dateFromISO8601 = function (isoDateString) {
        var parts = isoDateString.match(/\d+/g);
        var isoTime = Date.UTC(parts[0], parts[1] - 1, parts[2], parts[3], parts[4], parts[5]);
        var isoDate = new Date(isoTime);

        return isoDate;
    };

    searchInputWidth = searchInput.width();
    $('#searchResultAutocompleteWrapperContainer').find('.ui-autocomplete').css('width', searchInputWidth);
    $(window).on('resize', function () {
        $('#searchResultAutocompleteWrapperContainer').find('.ui-autocomplete').css('width', searchInputWidth);
    });

    if (view === 'genre' || view === 'keyword') {
        var werstreamesGenreRow = $('.werstreames-genre-row');
        var werstreamtesGenreContainer = $('#werstreamtesGenreContainer');
        werstreamesGenreRow.on('click touchstart', 'a', function (event) {
            event.preventDefault();
            werstreamtesGenreContainer.fadeOut('slow').remove();
            searchInput.val($.trim($(this).attr('data-werstreamtes-video-name'))).fadeIn('slow');
            werstreamtesSearchContainer.fadeIn('slow');
            searchResultWrapper.empty().fadeIn('slow');
            view = 'search';
            $('#werstreamesMainWrapper').attr('data-view', 'search');
            showMovieDetails(event, $(this).attr('data-werstreamtes-id'), version);
        });
    }
    if (view === 'search') {
        werstreamtesSearchContainer.show();
        searchInput.show();
        werstreamesMainWrapper.show();
    }
    var showMovieDetails = function (event, id, version) {
        version = version.toLowerCase();
        event.stopPropagation();
        $.ajax({
            url: "http://www.chip.de/werstreamtes/query.php",
            method: "get",
            dataType: "json",
            data: {
                searchType: 'details',
                id: id
            },
            beforeSend: function (xhr) {
                searchResultWrapper.empty();
                searchResultWrapper.html('<div class="search-loading-indicator-wrapper" id="searchLoadingIndicatorWrapper"><span class="search-loading-indicator" id="searchLoadingIndicator">Lade Daten</span></div>');
            }
        })
            .fail(function () {
                searchResultWrapper.empty();
                searchResultWrapper.append('Beim Laden der Daten ist leider ein Fehler aufgetreten. Bitte noch einmal versuchen.');
            })
            .always(function () {
            })
            .done(function (data) {
                var searchResultStreamsWrapperSpan = '';
                searchResultWrapper.empty().show();
                var response = data.response;
                var streams = response.Streams;
                searchResultWrapper.append('<div class="search-detail-movie-title-german-wrapper" id="searchDetailMovieTitleGermanWrapper"></div>');
                searchResultWrapper.append('<div class="search-detail-type-wrapper" id="searchDetailTypeWrapper"></div>');
                if (version === 'v2') {
                    searchResultWrapper.css('background', '#ffffff');
                    searchResultStreamsWrapperSpan = 'span12';
                }
                searchResultWrapper.append('<div class="search-result-streams-wrapper ' + searchResultStreamsWrapperSpan + '" id="searchResultStreamsWrapper"></div>');
                var searchDetailMovieTitleGermanWrapper = $('#searchDetailMovieTitleGermanWrapper');
                var searchDetailTypeWrapper = $('#searchDetailTypeWrapper');
                searchDetailTypeWrapper.append('<span class="search-detail-movie-title-original-wrapper" id="searchDetailMovieTitleOriginalWrapper"></span>');
                var searchDetailMovieTitleOriginalWrapper = $('#searchDetailMovieTitleOriginalWrapper');
                searchDetailMovieTitleGermanWrapper.append(response.Title);
                searchDetailMovieTitleOriginalWrapper.append(response.OriginalTitle);
                if (response.Type) {
                    if (response.OriginalTitle) {
                        searchDetailTypeWrapper.append('&nbsp;');
                        searchDetailTypeWrapper.append('|');
                        searchDetailTypeWrapper.append('&nbsp;');
                    }
                    if (response.Type === 'Movie') {
                        searchDetailTypeWrapper.append('<span class="search-result-type search-result-type-movie" id="searchResultType">Film</span>');
                    } else if (response.Type === 'Show') {
                        searchDetailTypeWrapper.append('<span class="search-result-type search-result-type-show" id="searchResultType">Serie</span>');
                    } else {
                        searchDetailTypeWrapper.append('<span class="search-result-type search-result-type-fallback" id="searchResultType">Film</span>');
                    }
                }
                if (response.Year) {
                    searchDetailTypeWrapper.append('&nbsp;');
                    searchDetailTypeWrapper.append('<span class="search-result-year" id="searchResultYear">' + response.Year + '</span>');
                }
                $(streams).each(function (index, item) {
                    var time = new Date(dateFromISO8601(item.Updated)).toLocaleTimeString();
                    var date = new Date(dateFromISO8601(item.Updated)).toLocaleDateString();
                    date = date + ' ' + time;
                    var offers = item.Offers;
                    var searchResultStreamsWrapper = $('#searchResultStreamsWrapper');
                    var wrapperClass = '';

                    if (version === 'v2') {
                        wrapperClass = 'search-result-stream-wrapper-v2';
                        if ($('.search-result-stream-wrapper').length === 0) {
                            searchResultStreamsWrapper.append('<div class="search-result-stream-wrapper search-result-stream-wrapper-v2 span12" id="searchResultStreamWrapper' + index + '"></div>');
                        }
                    }
                    if ($('#searchResultStreamWrapper' + index).length === 0 && version !== 'v2') {
                        searchResultStreamsWrapper.append('<div class="search-result-stream-wrapper span12' + wrapperClass + '" id="searchResultStreamWrapper' + index + '"></div>');
                    }
                    var searchResultStreamWrapper = $('#searchResultStreamWrapper' + index);
                    if (version !== 'v2') {
                        searchResultStreamWrapper.append('<div class="search-result-provider-title-wrapper" id="searchResultProviderTitleWrapper' + index + '"></div>');
                        $('#searchResultProviderTitleWrapper' + index).append('Anbieter: ' + item.ProviderTitle);
                    }
                    var indexBk = index;
                    var providerTitle = item.ProviderTitle;
                    var itemBk = item;
                    $(offers).each(function (index, item) {
                        var isLastItem = (index == (offers.length - 1));
                        if (version === 'v2') {
                            if ($('#searchResultMovieDetailsTabV2Wrapper').length === 0) {
                                searchResultStreamWrapper.append('<div class="search-result-movie-details-tab-v2-wrapper span12 tabreiter" id="searchResultMovieDetailsTabV2Wrapper"></div>');
                            }
                            var searchResultMovieDetailsTabV2Wrapper = $('#searchResultMovieDetailsTabV2Wrapper');
                            if ($('#werstreamtesTabContainer' + indexBk).length === 0) {
                                searchResultMovieDetailsTabV2Wrapper.append('<div class="werstreamtes-tab-container tab_container" id="werstreamtesTabContainer' + indexBk + '"></div>');
                            }
                            var werstreamtesTabContainer = $('#werstreamtesTabContainer' + indexBk);
                            if ($('#searchResultV2' + indexBk).length === 0) {
                                var listClass = '';
                                if (indexBk === 0) {
                                    listClass = 'active';
                                }
                                if ($('#werstreamtesV2TabsUl').length === 0) {
                                    werstreamtesTabContainer.append('<ul class="tabs span12" id="werstreamtesV2TabsUl">' +
                                    '</ul>');
                                }
                                $('#werstreamtesV2TabsUl').append('<li rel="tab' + indexBk + '" class="span4 ' + listClass + '">' +
                                providerTitle +
                                '</li>');
                                werstreamtesTabContainer.append('<div class="tab_content span12" id="tab' + indexBk + '">' +
                                '<div class="span12 full-height" id="searchResultV2' + indexBk + '">' +
                                '</div>' +
                                '</div>');
                            }
                            var searchResultV2Container = $('#searchResultV2' + indexBk);
                        }
                        if (item.Type === 'Flatrate') {
                            switch (version) {
                                case 'v1':
                                    if ($('#searchResultMovieDetailsFlatrateV1Wrapper' + indexBk).length === 0) {
                                        searchResultStreamWrapper.append('<div class="search-result-movie-details-v1-wrapper span9" id="searchResultMovieDetailsFlatrateV1Wrapper' + indexBk + '"></div>');
                                    }
                                    $('#searchResultMovieDetailsFlatrateV1Wrapper' + indexBk).append('<span class="span3 clear-right" id="searchResultFlatrateText' + indexBk + '">' +
                                        'Flatrate' +
                                        '</span>'
                                    );
                                    $('#searchResultMovieDetailsFlatrateV1Wrapper' + indexBk).append(
                                        '<span>' +
                                        'Gratis' +
                                        '</span>'
                                    );
                                    break;

                                case 'v2':
                                    if ($('#searchResultV2FlatrateWrapper' + indexBk).length === 0) {
                                        searchResultV2Container.append('<div class="span12 search-result-v2-wrapper" id="searchResultV2FlatrateWrapper' + indexBk + '"></div>');
                                    }
                                    $('#searchResultV2FlatrateWrapper' + indexBk).append(
                                        '<span class="span3">' +
                                        '<strong>Flatrate</strong>' +
                                        '</span>' +
                                        '<span class="span3">' +
                                        'Gratis' +
                                        '</span>');

                                    if ($('#searchResultButtonFlatrate' + indexBk).length === 0) {
                                        $('#searchResultV2FlatrateWrapper' + indexBk).append('<a href="' + itemBk.Link + '" target="_blank" class="search-result-button search-werstreamtes-button-red-v2" id="searchResultButtonFlatrate' + indexBk + '">Jetzt Laden</a>');
                                    }
                                    break;

                                case 'standard':
                                default:
                                    if ($('#searchResultStreamFlatrateWrapperContainer' + indexBk).length === 0) {
                                        searchResultStreamWrapper.append('<div class="search-result-stream-flatrate-wrapper-container span4" id="searchResultStreamFlatrateWrapperContainer' + indexBk + '"></div>');
                                    }
                                    var searchResultStreamFlatrateWrapperContainer = $('#searchResultStreamFlatrateWrapperContainer' + indexBk);
                                    searchResultStreamFlatrateWrapperContainer.append('<div class="search-result-flatrate-text-wrapper" id="searchResultFlatrateTextWrapper' + indexBk + '"></div>');
                                    $('#searchResultFlatrateTextWrapper' + indexBk).append('<span class="search-result-flatrate-text" id="searchResultFlatrateText' + indexBk + '">Flatrate</span>');
                                    searchResultStreamFlatrateWrapperContainer.append('<div class="search-result-flatrate-price-wrapper" id="searchResultFlatratePriceWrapper' + indexBk + '"></div>');
                                    $('#searchResultFlatratePriceWrapper' + indexBk).append('<span class="search-result-flatrate-price" id="searchResultFlatratePrice' + indexBk + '">Gratis</span>');
                                    break;
                            }

                        } else if (item.Type === 'Purchase') {
                            switch (version) {
                                case 'v1':
                                    if ($('#searchResultMovieDetailsPurchaseV1Wrapper' + indexBk).length === 0) {
                                        searchResultStreamWrapper.append('<div class="search-result-movie-details-v1-wrapper span9" id="searchResultMovieDetailsPurchaseV1Wrapper' + indexBk + '"></div>');
                                    }
                                    if ($("#searchResultPurchaseText" + indexBk).length == 0) {
                                        $('#searchResultMovieDetailsPurchaseV1Wrapper' + indexBk).append('<span class="span3 clear-right" id="searchResultPurchaseText' + indexBk + '">' +
                                            'Kaufen' +
                                            '</span>'
                                        );
                                    }
                                    $('#searchResultMovieDetailsPurchaseV1Wrapper' + indexBk).append(
                                        '<span class="span3 search-normal-font-weight clear-right">' +
                                        '<strong>' +
                                        item.Format +
                                        '</strong>' +
                                        '&nbsp;' +
                                        item.Price +
                                        ' ?</span>'
                                    );
                                    break;

                                case 'v2':
                                    if ($('#searchResultV2PurchaseWrapper' + indexBk).length === 0) {
                                        searchResultV2Container.append('<div class="span12 search-result-v2-wrapper" id="searchResultV2PurchaseWrapper' + indexBk + '"></div>');
                                    }
                                    if ($('#searchResultV2PurchaseText' + indexBk).length === 0) {
                                        $('#searchResultV2PurchaseWrapper' + indexBk).append('<span class="span3" id="searchResultV2PurchaseText' + indexBk + '">' +
                                        '<strong>Kaufen</strong>' +
                                        '</span>');
                                    }
                                    $('#searchResultV2PurchaseWrapper' + indexBk).append(
                                        '<span class="span3 search-normal-font-weight">' +
                                        '<strong>' +
                                        item.Format +
                                        '</strong>' +
                                        '&nbsp;' +
                                        item.Price +
                                        ' ?</span>');

                                    if ($('#searchResultButtonPurchase' + indexBk).length === 0) {
                                        $('#searchResultV2PurchaseWrapper' + indexBk).append('<a href="' + itemBk.Link + '" target="_blank" class="search-result-button search-werstreamtes-button-red-v2" id="searchResultButtonPurchase' + indexBk + '">Jetzt Laden</a>');
                                    }
                                    break;

                                case 'standard':
                                default:
                                    if ($('#searchResultStreamPurchaseWrapperContainer' + indexBk).length === 0) {
                                        searchResultStreamWrapper.append('<div class="search-result-stream-purchase-wrapper-container span4" id="searchResultStreamPurchaseWrapperContainer' + indexBk + '"></div>');
                                    }
                                    var searchResultStreamPurchaseWrapperContainer = $('#searchResultStreamPurchaseWrapperContainer' + indexBk);
                                    if ($("#searchResultBuyText" + indexBk).length == 0) {
                                        searchResultStreamPurchaseWrapperContainer.append('<div class="search-result-buy-text-wrapper" id="searchResultBuyTextWrapper' + indexBk + '"></div>');
                                        $('#searchResultBuyTextWrapper' + indexBk).append('<span class="search-result-buy-text" id="searchResultBuyText' + indexBk + '">Kaufen</span>');
                                    }
                                    searchResultStreamPurchaseWrapperContainer.append('<div class="search-result-buy-price-wrapper" id="searchResultBuyPriceWrapper' + indexBk + '"></div>');
                                    $('#searchResultBuyPriceWrapper' + indexBk).append('<div class="search-result-buy-price-' + item.Format + '-wrapper" id="searchResultBuyPrice' + item.Format + 'Wrapper' + indexBk + '"></div>');
                                    $('#searchResultBuyPrice' + item.Format + 'Wrapper' + indexBk).append('<span class="search-result-buy-price-format" id="searchResultBuyPriceFormat' + indexBk + '">' + item.Format);
                                    $('#searchResultBuyPrice' + item.Format + 'Wrapper' + indexBk).append('&nbsp;');
                                    $('#searchResultBuyPrice' + item.Format + 'Wrapper' + indexBk).append('<span class="search-result-buy-price" id="searchResultBuyPrice' + indexBk + '">' + item.Price + ' ?</span>&nbsp;');
                                    break;
                            }
                        } else if (item.Type === 'Rental') {
                            switch (version) {
                                case 'v1':
                                    if ($('#searchResultMovieDetailsV1Wrapper' + indexBk).length === 0) {
                                        searchResultStreamWrapper.append('<div class="search-result-movie-details-v1-wrapper span9" id="searchResultMovieDetailsV1Wrapper' + indexBk + '"></div>');
                                    }
                                    if ($("#searchResultRentalText" + indexBk).length == 0) {
                                        $('#searchResultMovieDetailsV1Wrapper' + indexBk).append('<span class="span3 clear-right" id="searchResultRentalText' + indexBk + '">' +
                                            'Leihen' +
                                            '</span>'
                                        );
                                    }
                                    $('#searchResultMovieDetailsV1Wrapper' + indexBk).append(
                                        '<span class="span3 search-normal-font-weight clear-right">' +
                                        '<strong>' +
                                        item.Format +
                                        '</strong>' +
                                        '&nbsp;' +
                                        item.Price +
                                        ' ?</span>'
                                    );
                                    break;

                                case 'v2':
                                    if ($('#searchResultV2RentalWrapper' + indexBk).length === 0) {
                                        searchResultV2Container.append('<div class="span12 search-result-v2-wrapper" id="searchResultV2RentalWrapper' + indexBk + '"></div>');
                                    }
                                    if ($('#searchResultV2RentalText' + indexBk).length === 0) {
                                        $('#searchResultV2RentalWrapper' + indexBk).append('<span class="span3" id="searchResultV2RentalText' + indexBk + '">' +
                                        '<strong>Leihen</strong>' +
                                        '</span>');
                                    }
                                    $('#searchResultV2RentalWrapper' + indexBk).append(
                                        '<span class="span3 search-normal-font-weight">' +
                                        '<strong>' +
                                        item.Format +
                                        '</strong>' +
                                        '&nbsp;' +
                                        item.Price +
                                        ' ?</span>');

                                    if ($('#searchResultButtonRental' + indexBk).length === 0) {
                                        $('#searchResultV2RentalWrapper' + indexBk).append('<a href="' + itemBk.Link + '" target="_blank" class="search-result-button search-werstreamtes-button-red-v2" id="searchResultButtonRental' + indexBk + '">Jetzt Laden</a>');
                                    }
                                    break;

                                case 'standard':
                                default:
                                    if ($('#searchResultStreamRentalWrapperContainer' + indexBk).length === 0) {
                                        searchResultStreamWrapper.append('<div class="search-result-stream-rental-wrapper-container span4" id="searchResultStreamRentalWrapperContainer' + indexBk + '"></div>');
                                    }
                                    var searchResultStreamRentalWrapperContainer = $('#searchResultStreamRentalWrapperContainer' + indexBk);
                                    if ($("#searchResultRentalText" + indexBk).length == 0) {
                                        searchResultStreamRentalWrapperContainer.append('<div class="search-result-rental-text-wrapper" id="searchResultRentalTextWrapper' + indexBk + '"></div>');
                                        $('#searchResultRentalTextWrapper' + indexBk).append('<span class="search-result-rental-text" id="searchResultRentalText' + indexBk + '">Leihen</span>');
                                    }
                                    searchResultStreamRentalWrapperContainer.append('<div class="search-result-rental-price-wrapper" id="searchResultRentalPriceWrapper' + indexBk + '"></div>');
                                    $("#searchResultRentalPriceWrapper" + indexBk).append('<div class="search-result-rental-price-' + item.Format + '-wrapper" id="searchResultRentalPrice' + item.Format + 'Wrapper' + indexBk + '"></div>');
                                    $('#searchResultRentalPrice' + item.Format + 'Wrapper' + indexBk).append('<span class="search-result-rental-price-format" id="SearchResultRentalPriceFormat' + indexBk + '">' + item.Format + '</span>');
                                    $('#searchResultRentalPrice' + item.Format + 'Wrapper' + indexBk).append('&nbsp;');
                                    $('#searchResultRentalPrice' + item.Format + 'Wrapper' + indexBk).append('<span class="search-result-rental-price" id="SearchResultRentalPrice' + indexBk + '">' + item.Price + ' ?</span>');
                                    break;
                            }
                        }

                        if (version === 'v2' && isLastItem) {
                            if ($('#searchResultV2Timestamp' + indexBk).length === 0) {
                                searchResultV2Container.append('<span class="search-result-v2-timestamp span12" id="searchResultV2Timestamp' + indexBk + '">' +
                                'Letzte Aktualisierung: ' + date +
                                '</span>');
                            }
                        }
                    });
                    switch (version) {
                        case 'v1':
                            $(searchResultStreamWrapper).append('<div class="search-result-button-wrapper-v1 span3" id="searchResultButtonWrapper' + index + '"></div>');
                            $('#searchResultButtonWrapper' + index).append('<a href="' + item.Link + '" target="_blank" class="search-result-button search-werstreamtes-button-red-v1" id="searchResultButton' + index + '">Jetzt Laden</a>');
                            break;

                        case 'v2':
                            break;

                        case 'standard':
                        default:
                            searchResultStreamWrapper.append('<div class="search-result-button-wrapper" id="searchResultButtonWrapper' + index + '"></div>');
                            $('#searchResultButtonWrapper' + index).append('<a href="' + item.Link + '" target="_blank" class="search-result-button search-werstreamtes-button-red" id="searchResultButton' + index + '">Jetzt Laden</a>');
                            break;
                    }
                    if (version !== 'v2') {
                        searchResultStreamWrapper.append('<div class="search-result-timestamp-wrapper span12" id="searchResultTimestampWrapper' + index + '"></div>');
                        $('#searchResultTimestampWrapper' + index).append('<p class="search-timestamp" id="searchResultTimestamp' + index + '"></p>');
                        $("#searchResultTimestamp" + index).html('Letzte Aktualisierung: ' + date);
                    }

                    if (version === 'v2') {
                        $(".tab_content").hide();
                        $(".tab_content:first").show();
                        $("ul.tabs li").click(function () {
                            $("ul.tabs li").removeClass("active");
                            $(this).addClass("active");
                            $(".tab_content").hide();
                            var activeTab = $(this).attr("rel");
                            $("#" + activeTab).fadeIn();
                        });
                    }
                });
                if (response.Link) {
                    searchResultWrapper.append('<div class="search-result-more-link-wrapper span12" id="searchResultMoreLinkWrapper"></div>');
                    $('#searchResultMoreLinkWrapper').append('<a target="_blank" href="' + response.Link + '" class="search-result-more-link search-werstreamtes-button-grey" id="searchResultMoreLink">MEHR ANGEBOTE AUF WERSTREAMT.ES</a>');
                }
            });
    };
    var searchResult = function (event) {
        event.stopPropagation();
        var searchInputValue = searchInput.val();
        if (searchInputValue === '') {
            searchResultWrapper.empty();
            return
        }
        $.ajax({
            url: "http://www.chip.de/werstreamtes/query.php",
            method: "get",
            dataType: "json",
            data: {
                searchType: "search",
                searchString: searchInputValue,
                filter: 'filme-serien',
                limit: 10,
                offset: 0
            },
            beforeSend: function (xhr) {
                searchResultWrapper.empty();
                searchResultWrapper.html('<div class="search-loading-indicator-wrapper" id="searchLoadingIndicatorWrapper"><span class="search-loading-indicator" id="searchLoadingIndicator">Lade Daten</span></div>');
            }
        })
            .fail(function () {
                searchResultWrapper.empty();
                searchResultWrapper.append('Beim Laden der Daten ist leider ein Fehler aufgetreten. Bitte noch einmal versuchen.');
            })
            .always(function () {
            })
            .done(function (data) {
                if (data.response.TotalItems > 0) {
                    searchResultWrapper.empty().show();
                    var response = data.response;
                    var items = response.Items;
                    $.each(items, function (index, item) {
                        searchResultWrapper.append('<div id="searchResultId" class="search-result-id" aria-hidden="true" hidden="hidden" style="visibility: hidden; display: none" data-searchResultId="' + item.ID + '"></div>');
                        searchResultWrapper.append('<div class="search-result-single-wrapper" id="searchResult' + index + '"></div>');
                        var searchResultSingleWrapper = $('#searchResult' + index);
                        if (item.Title) {
                            searchResultSingleWrapper.append('<h3 class="search-result-german-title" id="searchResultGermanTitle' + index + '">' + item.Title + '</h3>');
                        }
                        if (item.OriginalTitle || item.Type || item.Year) {
                            searchResultSingleWrapper.append('<div class="search-meta-data-wrapper" id="searchMetaDataWrapper' + index + '"></div>');
                            var searchMetaDataWrapper = $('#searchMetaDataWrapper' + index);
                            if (item.OriginalTitle) {
                                searchMetaDataWrapper.append('<span class="search-result-original-title" id="searchResultOriginalTitle' + index + '">' + item.OriginalTitle + '</span>');
                                searchMetaDataWrapper.append('&nbsp;');
                            }
                            if ((item.Type && item.OriginalTitle) || (item.Year && item.OriginalTitle)) {
                                searchMetaDataWrapper.append('&nbsp;');
                                searchMetaDataWrapper.append('|');
                                searchMetaDataWrapper.append('&nbsp;');
                            }
                            if (item.Type) {
                                if (item.Type === 'Movie') {
                                    searchMetaDataWrapper.append('<span class="search-result-type search-result-type-movie" id="searchResultType' + index + '">Film</span>');
                                } else if (item.Type === 'Show') {
                                    searchMetaDataWrapper.append('<span class="search-result-type search-result-type-show" id="searchResultType' + index + '">Serie</span>');
                                } else {
                                    searchMetaDataWrapper.append('<span class="search-result-type search-result-type-fallback" id="searchResultType' + index + '">Film</span>');
                                }
                                searchMetaDataWrapper.append('&nbsp;');
                            }
                            if (item.Year) {
                                searchMetaDataWrapper.append('<span class="search-result-year" id="searchResultYear' + index + '">' + item.Year + '</span>');
                                if (item.Type) {
                                    searchMetaDataWrapper.append('&nbsp;');
                                }
                            }
                        }
                        $(searchResultSingleWrapper).on('click touchstart', function (event) {
                            showMovieDetails(event, item.ID, version);
                        });
                    });
                    if (response.SearchUrl) {
                        searchResultWrapper.append('<div class="search-result-more-link-wrapper span12" id="searchResultMoreLinkWrapper"></div>');
                        $('#searchResultMoreLinkWrapper').append('<a target="_blank" href="' + response.SearchUrl + '" class="search-result-more-link search-werstreamtes-button-grey" id="searchResultMoreLink">MEHR ANGEBOTE AUF WERSTREAMT.ES</a>');
                    }
                } else {
                    searchAlert.html('Wir konnten keinen Beitrag in unserer Datenbank finden, der zu Ihrem Suchbegriff passt.').show();
                    searchAlertWrapper.show();
                }
            });
    };
    var showSearchResultList = function (event) {
        searchInput.autocomplete("close");
        searchResult(event);
    };
    searchAlertWrapperCloseIcon.on('click touchstart', function () {
        searchAlertWrapper.hide();
    });
    searchIconMagnifyingGlass.off().on('click touchstart', function (event) {
        event.preventDefault();
        showSearchResultList(event);
    });
    $(searchInput).autocomplete({
        minLength: 2,
        delay: 500,
        source: function (request, response) {
            $.ajax({
                url: "http://www.chip.de/werstreamtes/query.php",
                method: "get",
                dataType: "json",
                type: 'GET',
                data: {
                    searchType: "searchAutocomplete",
                    searchString: searchInput.val(),
                    filter: 'filme-serien',
                    limit: 10,
                    offset: 0
                },
                success: function (data) {
                    if ($.isEmptyObject(data)) {
                        searchAlert.html('Wir konnten keinen Beitrag in unserer Datenbank finden, der zu Ihrem Suchbegriff passt.').show();
                        searchAlertWrapper.show();

                        return 1;
                    }
                    searchAlert.hide();
                    searchAlertWrapper.hide();
                    response($.map(data, function (item) {
                        return {
                            id: item.ID,
                            name: item.Title,
                            originalName: item.OriginalTitle,
                            year: item.Year,
                            type: item.Type
                        };
                    }));
                }
            });
        },
        messages: {
            noResults: '',
            results: function () {
            }
        },
        focus: function (event, ui) {
            event.preventDefault();
        },
        select: function (event, ui) {
            event.preventDefault();
            showMovieDetails(event, ui.item.id, version);
        },
        open: function (event, ui) {
            $('.ui-autocomplete').append('<li class="ui-menu-item" id="searchResultShowAllResultsLinkList"><a href="#" class="search-results-show-all-results-link" id="searchResultShowAllResultsLink">Alle Ergebnisse fr: </a><span class="search-results-show-all-results-link-red" id="searchResultsShowAllResultsLinkRed">' + searchInput.val() + '</span></li>');
            $('#searchResultShowAllResultsLinkList').off().on('click touchstart', function (event) {
                event.preventDefault();
                showSearchResultList(event);
            });
        }
    }).keyup(function (e) {
        if (e.which === 13) {
            showSearchResultList(e);
        }
    }).data("ui-autocomplete")._renderItem = function (ul, item) {
        var $container = $("<div></div>");
        if (item.movieImage) {
            var $searchResultAutocompleteListMetaDataWrapperImageWrapper = $("<div id='searchResultAutocompleteListMetaDataWrapperImageWrapper' class='search-result-autocomplete-list-meta-data-wrapper-image-wrapper'></div>").appendTo($container);
            $("<img src='" + item.movieImage + "' class='search-result-autocomplete-list-movie-image'>").appendTo($searchResultAutocompleteListMetaDataWrapperImageWrapper);
        }
        var $searchResultAutocompleteListMetaDataWrapperContainer = $("<div id='searchResultAutocompleteListMetaDataWrapperContainer' class='search-result-autocomplete-list-meta-data-wrapper-container'></div>").appendTo($container);
        if (item.movieImage) {
            $searchResultAutocompleteListMetaDataWrapperContainer.css('float', 'right');
        }
        $("<span class='search-result-autocomplete-list-name'></span>").text(item.name).appendTo($searchResultAutocompleteListMetaDataWrapperContainer);
        var $searchResultAutocompleteListMetaDataWrapper = $("<div class='search-result-autocomplete-list-meta-data-wrapper'></div>").appendTo($searchResultAutocompleteListMetaDataWrapperContainer);
        if (item.originalName) {
            $("<span class='search-result-autocomplete-list-original-name'></span>").text(item.originalName).appendTo($searchResultAutocompleteListMetaDataWrapper);
            if (item.year || item.type) {
                $("<span class='search-result-autocomplete-list-separator'></span>").text(' | ').appendTo($searchResultAutocompleteListMetaDataWrapper);
            }
        }
        if (item.type === 'Movie') {
            $("<span class='search-result-autocomplete-list-type'></span>").text('Film ').appendTo($searchResultAutocompleteListMetaDataWrapper);
        } else {
            $("<span class='search-result-autocomplete-list-type'></span>").text('Serie ').appendTo($searchResultAutocompleteListMetaDataWrapper);
        }
        if (item.year) {
            $("<span class='search-result-autocomplete-list-year'></span>").text(item.year).appendTo($searchResultAutocompleteListMetaDataWrapper);
        }
        return $("<li></li>").append($container).appendTo(ul);
    };
    searchInput.autocomplete({appendTo: "#wersuchtesSearchResultAutocompleteWrapper"});
    $(window).resize(function () {
        var position = $("#searchInput").position();
        var properties = {
            left: position.left,
            top: position.bottom
        };
        $(".ui-autocomplete").css(properties);
    });
    searchInput.on('input', function () {
        if (searchInput.val() === '') {
            searchResultWrapper.empty().hide();
        }
    });
});