// User options for overriding core options.js
var path = require('path');
var _ = require('lodash');

module.exports = {
    // Restart the app after changing core (back-end) options
    // Core options could be only redefined from user/options.js, context options are not supported
    core: {
       /* processMd: {
            languageRenderers: {
                js:   'sourcejs-contrib-js/lang-javascript'
            }
        }*/
    },
    server: {
        port: 9012,
        hostname: 'http://fed.cxo.name'
    },

    // Page rendering configuration (redefinable from context options)
    rendering: {

        views: {
            defaultViewPaths: [
                '$(user)/core/views',
                '$(sourcejs)/core/views'
            ],
            spec: [
                '$(user)/core/views/spec.ejs',
                '$(sourcejs)/core/views/spec.ejs'
            ],
            navigation: [
                '$(user)/core/views/navigation.ejs',
                '$(sourcejs)/core/views/navigation.ejs'
            ]
        }

    },

    // Client-side options (redefinable from context options)
    assets: {
        // Page classes
        containerClass : 'source_container',
        headerClass : 'source_header',
        SECTION_CLASS : 'source_section',
        exampleSectionClass : 'source_example',
        exampleCleanClass : 'source_clean',
        mainClass : 'source_main',
        mainNav : 'source_main_nav',
        colMain : 'source_col-main',

        modulesEnabled: {
            // Overriding example
            // trimSpaces: true
        },

        moduleOptions: {

            // Modules options example
            // navHighlight: {
            //     updateHash: false
            // }

            globalNav: {

                templates: {
                    catalogHeader: _.template('<h2 class="custom"> <%= catalogMeta.title %></h2>'),
                },

                classes: {
                    "catalog": "source_catalog",
                    "catalogList": "source_catalog_list",
                    "catalogListItem": "source_catalog_list_i",
                    "catalogListAll": "source_catalog_all",
                    "catalogLinkToAll": "source_a_bl",
                    "catalogImageThumbler": "source_catalog_image-tumbler",
                    "catalogListLink": "source_catalog_a",
                    "catalogListImage": "source_catalog_img",
                    "catalogListTitle": "source_catalog_title",
                    "catalogListDate": "source_catalog_footer",
                    "catalogFilter" : "source_catalog-filter",
                    "sourceSubhead" : "source_subhead",
                    "catalogText": "source_catalog_tx",
                    "showPreview": "__show-preview",
                    "updateButton": "source_catalog_update-button"
                },

            },

        },

        // Legacy options object support for some older plugins
        pluginsOptions: {}
    },

    // External plugins options (are also exposed to client-side
    plugins: {
      /* specDependenciesTree: {
            includedDirs: ['specs']
        },*/
        css: {
            targetCssMask: '**/*.{css,sass,scss}',

                templates: {
                   sections: path.join(__dirname, 'core/views/sections_css.ejs')
                }
        },
        js: {
            targetJsMask: '**/*.js',
            visibleCode: true,
            templates: {
                 //  sections: path.join(__dirname, 'core/views/sections_js.ejs')
            }
        }
    }
};
